//
// Mode 0 Demo
//
// by dancotter@optushome.com.au
//
// this demo shows how to display a tile map of characters tiles
// using mode 0. The user can then use the joy pad to move the map around
// which is done by scrolling the map ground.

// NOTE THAT IF YOU ARE CHANGING THE MAP.BMP YOU MUST MAKE SURE THAT YOU DONT
// CREATE TO MANY DIFFERENT TILES!

// the map is made up of 156 different 8x8pixel characters (tiles)

//includes:
#include "..\..\lib\gba.h" //gameboy advance header file
#include "mapdata.h" //character map data (Screen data)
#include "chardata.h" //character data (char data)
#include "paldata.h" //pallette data  (colors)

void AGBMain() //start of main code
	{
      u8 x=0;//x co-ord for scrolling
      u8 y=0;//y co-ord for scrolling

		//set video mode to mode0
		mode0();

      forceblankoff();
      //turn on the screen

      //load the character data to bank 0
      //since there are 156 characters, each made up of 64 characters,
      //there are 11904 bytes of data to load.
      loadchardata(0, chardata, 9984);

      //load the screen data to vram
      //i picked block 13 for no particular reason...
      //since the screen map is 32 by 32 tiles (which is 1024 tiles)
      //we need to load 1024 half words
      loadscreendatatxt(13, mapdata, 1024);

      //load the background color palette
      set_pal(paldata, 0, 256);

      //set the background to 256x256
      txtbgsize256x256(&REG_BG0CNT);

      //set the screen base block to 13 (this is the block where we loaded
      //data to above)
      bgscrnbaseblock(&REG_BG0CNT,13);

      //same thing for character base block
      bgcharbaseblock(&REG_BG0CNT,0);

      //using multiple baseblocks we could store lots of maps and character
      //data in the vram and quickly switch between them with out having
      //to load from the cart.

      //set the background to 256 colors, 1 palette.
      bg256x1col(&REG_BG0CNT);

      //turn he background on:
      background0on();

      while(!0)
      //loop for ever
      	{
         //wait for vertical blank to start
         wait_vbl_start(1);

         //scroll the background
         scrollbg0(x,y);

         //if the joypad is being pressed change the scrolling co-ords
         if(pad(J_UP) == 1) y--;
         if(pad(J_DOWN) == 1) y++;
			if(pad(J_LEFT) == 1) x--;
         if(pad(J_RIGHT) == 1) x++;

         }
	}
