//
// Mode 3 Demo
//
// by dancotter@optushome.com.au
//
// This demo shows how to display a picture in mode 3.
// It also shows how to put and get pixels.
// The picture is from the .raw file (high color) saved from
// paint shop pro.

//Because i am bored i made this demo do something a bit more interesting...
//it will draw blocks onto the screen made up by a number of pixels, the blocks
//will spiral around until the whole image is covered up.

#define SIZE 8//length in pixels of blocks to draw (height is the same).
              //because of the way the program works it must be a number
              //that is devisable up the screen length and width with no
              //remainder
#define COLOR 0x7FC3 //define the color so that we can change it easy
						   //because of the way the program works it must not be color
                     //which is already part of the image, as it see if the
                     //color is ahead and changes the draw direction if it is.

//includes:
#include "..\..\lib\gba.h" //gameboy advance header file
#include "m3pic.h" //picture information

void AGBMain() //start of main code
	{

      //declare variables
      u16 i=0;//draw-direction counter
		u16 a=0;//x co-ordinate counter
		u16 b=0;//y co-ordinate counter
      u16 j=0;//loop counter
      u16 k=0;//loop counter

		//set video mode to 3
		mode3();

      //load the buffer with picture data
		m3_loadbuffer(m3pic);
      
      forceblankoff();
      //turn on the screen


		//turn background2 on (background 2 is the only one which is used
      //in mode 3).
		background2on();

      while(!(volatile)0)
      //loop for ever
      	{
         //wait for vertical blank to start
         //dont draw multiple pixels when not in a blanking interval
         wait_vbl_start(1);

         //place the pixels for the block
         for(j=0;j<SIZE;j++)
         	for(k=0;k<SIZE;k++)
					m3_put_pixel(a+j,b+k,COLOR);

         //change the x and y co-ords depending on the draw direction
         switch (i)
         	{
         	case 0 : a+=SIZE; break;
         	case 1 : b+=SIZE; break;
         	case 2 : a-=SIZE; break;
         	case 3 : b-=SIZE; break;
            }

         //change the draw direction if the end of the screen is reached
         if((a == 240-SIZE) && (b == 0)) i = 1;
         if((a == 240-SIZE) && (b == 160-SIZE)) i = 2;
         if((a == 0) && (b == 160-SIZE)) i = 3;
         if((a == 0) && (b == 0)) i = 0;

         //change the draw direction if the pixel ahead has already been drawn
         if((i==0) && (m3_get_pixel(a+SIZE,b) == COLOR)) i = 1;
         if((i==1) && (m3_get_pixel(a,b+SIZE) == COLOR)) i = 2;
         if((i==2) && (m3_get_pixel(a-SIZE,b) == COLOR)) i = 3;
         if((i==3) && (m3_get_pixel(a,b-SIZE) == COLOR)) i = 0;


         }
	}
