//
// Mode 4 Demo
//
// by dancotter@optushome.com.au
//
//
//This demo displays 4 pictures in mode 4, fading to a color and back between
//each picture. The user must also press start to change pictures.

//includes:
#include "..\..\lib\gba.h" //gameboy advance header file with all the functions
#include "demoraw.h" //info of pictures
#include "demopal.h" //pallette info (colors of the pictures)

void AGBMain()
	{
      //define variables
		u32 palcnt=0;//palette counter
		u32 datcnt=0;//picture data counter
      u16 color=0;//which color we want to get from the array
      cu16 colors[] = //array of colors
			{
			C_BLACK,C_DARKRED,C_RED,C_BROWN,C_DARKGREEN,C_TEAL,C_ORANGE,C_DARKYELLOW,
			C_GREEN,C_YELLOW,C_DARKGRAY,C_DARKBLUE,C_LIGHTFLESH,C_PURPLE,C_LIGHTGRAY,C_AQUA,
			C_BLUE,C_PINK,C_CYAN,C_WHITE
			};//20 colors

		//set video mode to 4
		mode4();

      //loadbuffer0 with picture data
		m4_loadbuffer(demoraw+datcnt,0);

		//load color pallette with color data
		set_pal(demopal, 0, 256);

      forceblankoff();
      //turn on the screen

		//turn background2 on (background 2 is the only one which is used
      //in mode 4.
		background2on();

      //loop forever....
		while(!0)
			{
            //waits till start button is being pressed
            wait_pad(J_START);

            //waits till no buttons are being pressed
            wait_pad_up();

            //fade the palette to a color
				bg_pal_to(colors[color],1);
            color++;//next color
            if(color==20)color=0;//since only 20 colors, reset to 0 if 20.

            //increment data offsets, so we can load the next picture's data
				palcnt+=256;
				datcnt+=19200;

            //since there are only 4 picture, the data counters must be reset
            //after 4 pictures have been shown
            if(palcnt == 1024)//after 4 pics palcnt will be 1024
            	{
            	palcnt = 0;
               datcnt = 0;
               }

				//loadbuffer with the next picture
				m4_loadbuffer(demoraw+datcnt,0);

				//fade from color to pal
				to_bg_pal(demopal+palcnt,1);
			}
	}
