//GBA - object attribute memory header
//by dancotter@optushome.com.au

//defines:

#define OAM0_256COL 0x2000
#define OAM0_16COL 0x0000

#define OAM0_MOASIC 0x1000

#define OAM0_NORMAL 0x0000
#define OAM0_SEMI   0x0400
#define OAM0_WINDOW 0x0800

#define OAM0_SINGLE 0x0000
#define OAM0_DOUBLE 0X0200

#define OAM0_RS 0x0100

#define OAM1_VERTICAL 0x2000
#define OAM1_HORIZONTAL 0x1000

#define OAM2_PRIORITY0 0x0000
#define OAM2_PRIORITY1 0x0400
#define OAM2_PRIORITY2 0x0800
#define OAM2_PRIORITY3 0x0C00


void set_obj_a0 (u16 obj, u16 bits)
{
u16* attrib = &MEM_OAM;
attrib += obj<<2;
*attrib &= 0xC0FF;
*attrib |= bits;
}

void set_obj_a1 (u16 obj, u16 bits)
{
u16* attrib = &MEM_OAM;
attrib+= (obj<<2) + 1;
*attrib &= 0xC1FF;
*attrib |= bits;
}

void set_obj_a2 (u16 obj, u16 bits)
{
u16* attrib = &MEM_OAM;
attrib+= (obj<<2) + 2;
*attrib &= 0xF3FF;
*attrib |= bits;
}

void set_sprite_pos(u16 obj, u16 x, u16 y)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj<<2);
*attrib &= 0xFF00;
*attrib |= y;
attrib++;
*attrib &= 0xFE00;
*attrib |= x;
}

void set_sprite_num(u16 obj, u16 num)
{
u16 *  attrib = &MEM_OAM;
attrib+= (obj<<2);
attrib+=2;
*attrib &= 0xFC00;
*attrib|= num;
}

void set_sprite_size8x8(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;

attrib++;
*attrib &= 0x3FFF;

}

void set_sprite_size16x16(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0x4000;
}

void set_sprite_size32x32(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0x8000;
}

void set_sprite_size64x64(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0xC000;
}

void set_sprite_size16x8(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;
*attrib |= 0x4000;

attrib++;
*attrib &= 0x3FFF;
}

void set_sprite_size32x8(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;
*attrib |= 0x4000;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0x4000;
}

void set_sprite_size32x16(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;
*attrib |= 0x4000;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0x8000;
}

void set_sprite_size64x32(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;
*attrib |= 0x4000;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0xC000;
}

void set_sprite_size8x16(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;
*attrib |= 0x8000;

attrib++;
*attrib &= 0x3FFF;
}

void set_sprite_size8x32(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;
*attrib |= 0x8000;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0x4000;
}

void set_sprite_size16x32(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;
*attrib |= 0x8000;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0x8000;
}

void set_sprite_size32x64(u16 obj)
{
u16 * attrib = &MEM_OAM;
attrib+= (obj << 2);
*attrib &= 0x3FFF;
*attrib |= 0x8000;

attrib++;
*attrib &= 0x3FFF;
*attrib |= 0xC000;
}


