//GBA Palette Header File
//by dancotter@optushome.com.au

void pal_to(u16 color, u16 period, u8 pl)
	{
   u16 j=0;
   u16 k=0;
   do
   	{
   	u16 cnt = 0;
   	u16 *pal;
      if(pl == 0) pal = &MEM_PALBG;
      else pal = &MEM_PALOBJ;
      wait_vbl_start(period);
   	for(cnt=0;cnt<256;cnt++)
   		{
      	if ((*pal & 0x7C00) < (color & 0x7C00)) *pal+=0x400;
         if ((*pal & 0x7C00) > (color & 0x7C00)) *pal-=0x400;
         if ((*pal & 0x03E0) < (color & 0x03E0)) *pal+=0x20;
         if ((*pal & 0x03E0) > (color & 0x03E0)) *pal-=0x20;
         if ((*pal & 0x001F) < (color & 0x001F)) *pal+=0x01;
         if ((*pal & 0x001F) > (color & 0x001F)) *pal-=0x01;
			if (*pal == color) k++;
         else k=0;
         if (k == 256) j = 32;
         pal++;
   		}
      j++;
   	}
   while(j < 32);
	}

void bg_pal_to(u16 color,u16 period)
	{
   pal_to(color,period, 0);
   }

void obj_pal_to(u16 color, u16 period)
	{
   pal_to(color,period, 1);
   }

void to_pal(u16 period, const u16 *color, u8 pl)
	{
   u16 j=0;
   u16 k=0;
   do
   	{
   	u16 cnt = 0;
   	u16 *pal;
      if(pl == 0) pal = &MEM_PALBG;
      else pal = &MEM_PALOBJ;
      wait_vbl_start(period);
   	for(cnt=0;cnt<256;cnt++)
   		{
      	if ((*pal & 0x7C00) < (*color & 0x7C00)) *pal+=0x400;
         if ((*pal & 0x7C00) > (*color & 0x7C00)) *pal-=0x400;
         if ((*pal & 0x03E0) < (*color & 0x03E0)) *pal+=0x020;
         if ((*pal & 0x03E0) > (*color & 0x03E0)) *pal-=0x20;
         if ((*pal & 0x001F) < (*color & 0x001F)) *pal+=0x01;
         if ((*pal & 0x001F) > (*color & 0x001F)) *pal-=0x01;
			if (*pal == *color) k++;
         else k=0;
         if (k == 256) j = 32;
         pal++;
         color++;
   		}
      j++;
      color-=256;
   	}
   while(j < 32);
	}

void to_bg_pal(const u16 *color,u16 period)
	{
   to_pal(period,color, 0);
   }

void to_obj_pal(const u16 *color, u16 period)
	{
   to_pal(period,color, 1);
   }

void set_pal_color(u16 color_num,u16 color)
	{
	u16 *pal = &MEM_PALBG;
	pal+=color_num;
	*pal = color;
	}

void set_pal(const u16 *dat, u16 start, u16 num)
	{
	u16 *pal = &MEM_PALBG;
   pal+=start;
	do
		{
		*pal = *dat; dat++; pal++; num--;
		}
	while(num>0);
	}

void inv_pal(u16 startcolor, u16 numofcols)
	{
	u16 *pallbg = &MEM_PALBG;
   pallbg+=startcolor;
	do
   	{
		*pallbg = (*pallbg & 0x7FFF) ^ 0x7FFF;
		pallbg++;
      numofcols--;
		}
	while(numofcols>0);
	}


void col_to(u16 color, u16 period, u16 colornum)
	{
   u16 j=0;
 	u16 *pal;
   pal = &MEM_PALBG;
   pal+=colornum;
   do
   	{
      wait_vbl_start(period);
   		if ((*pal & 0x7C00) < (color & 0x7C00)) *pal+=0x400;
         if ((*pal & 0x7C00) > (color & 0x7C00)) *pal-=0x400;
         if ((*pal & 0x03E0) < (color & 0x03E0)) *pal+=0x20;
         if ((*pal & 0x03E0) > (color & 0x03E0)) *pal-=0x20;
         if ((*pal & 0x001F) < (color & 0x001F)) *pal+=0x01;
         if ((*pal & 0x001F) > (color & 0x001F)) *pal-=0x01;
         j++;
         if(*pal == color) j = 32;
   	}
   while(j < 32);
	}
